package widebase.rpc

import widebase.db.table.Table
import widebase.rpc.interface.ClientInterface
import widebase.rpc.table. { RemoteTableFind, RemoteTableLoad, RemoteTableSave }

/** Proxy to [[widebase.rpc.ClientInterface]].
 *
 * @author myst3r10n
 */
trait Proxy extends msgpack.rpcx.Proxy {

  import vario.filter.StreamFilter.StreamFilter

  import widebase.rpc.table.props

  /** Proxy to client interface. */
  protected val proxy: ClientInterface

  /** Checks whether remote table exists. */
  object find extends RemoteTableFind(proxy, authId)

  /** Load table from remote database. */
  object load extends RemoteTableLoad(proxy, authId)

  /** Save table into remote database. */
  object save extends RemoteTableSave(proxy, authId)

  /** Shutdown server remotelly. */
  def remoteShutdown {

    proxy.remoteShutdown(authId)

  }
}

